<?php

App::uses('CakeEventListener', 'Event');

class EvInventoryWarningLevelListener implements CakeEventListener {

	public function implementedEvents() {
		return array(
			'EvInventory.Behavior.Inventory.saved' => array(
				'callable' => 'checkLevel',
				'priority' => 50
			)
		);
	}

	/**
	 * check the warning level
	 *
	 */
	public function checkLevel(CakeEvent $Event) {
		$modelName = EvClassRegistry::getNameFromModel($Event->subject());

		$Inventory = EvClassRegistry::init('EvInventory.Inventory');

		$itemInventory = $Inventory->getInventory($modelName, $Event->data['id']);

		if ($itemInventory['Inventory']['stock'] <= $itemInventory['Inventory']['warning_level'] && $itemInventory['Inventory']['stock'] > 0) {
			$Inventory->warningLevelReached($itemInventory);
		}

		return true;
	}
}
